/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jboss.wsse.client;

import java.net.URL;
import java.security.Security;
import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Service;
import org.apache.cxf.ws.security.SecurityConstants;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.jboss.test.ws.jaxws.samples.wsse.policy.ServiceIface;



/**
 *
 * @author juan
 */
public class Client {
    private static final String serviceURL = "http://localhost:8080/WSSecureTest";
    
    public static void main(String args[]){
        Security.addProvider(new BouncyCastleProvider());
        sayHello();
    }
    
    

    public static void sayHello()
    {
        try{
            QName serviceName =new QName("http://www.jboss.org/jbossws/ws-extensions/wssecuritypolicy", "SecurityService");
            URL wsdlURL = new URL(serviceURL + "?wsdl");
            System.out.println("Estableciendo comunicación segura...");
            Service service = Service.create(wsdlURL, serviceName);
            ServiceIface proxy = (ServiceIface)service.getPort(ServiceIface.class);
            System.out.println("Servicio contactado, inicializando configuración de seguridad...");
            setupWsse(proxy);
            System.out.println("Comunicación establecida...");
            System.out.println("Ejecutando acción en plataforma..");
            System.out.println(proxy.sayHello());
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }
   
    private static void setupWsse(ServiceIface proxy)
    {
        ((BindingProvider)proxy).getRequestContext().put(SecurityConstants.CALLBACK_HANDLER, new KeystorePasswordCallback());
        ((BindingProvider)proxy).getRequestContext().put(SecurityConstants.SIGNATURE_PROPERTIES, Thread.currentThread().getContextClassLoader().getResource("META-INF/alice.properties"));
        ((BindingProvider)proxy).getRequestContext().put(SecurityConstants.ENCRYPT_PROPERTIES, Thread.currentThread().getContextClassLoader().getResource("META-INF/alice.properties"));
        ((BindingProvider)proxy).getRequestContext().put(SecurityConstants.SIGNATURE_USERNAME, "alice");
        ((BindingProvider)proxy).getRequestContext().put(SecurityConstants.ENCRYPT_USERNAME, "bob");
    }

   
}
